public class LCS {
	private final int dp[][];
	private final int par[][];
	private final String A, B;
	
	public LCS(String A, String B) {
		this.A = A;
		this.B = B;
		dp = new int[A.length() + 1][B.length() + 1];
		par = new int[A.length() + 1][B.length() + 1];
	}
	
	public int longestCommonSubsequence() {
        for (int i = 0; i < A.length(); ++i) {
            for (int j = 0; j < B.length(); ++j) {
                // Skip either character.
            	if (dp[i][j+1] < dp[i+1][j]) {
            		dp[i+1][j+1] = dp[i+1][j];
            		par[i+1][j+1] = 0;
            	} else {
            		dp[i+1][j+1] = dp[i][j+1];
            		par[i+1][j+1] = 1;
            	}
                // If they are equal, then extend previous matching.
                if (A.charAt(i) == B.charAt(j) && dp[i+1][j+1] < 1 + dp[i][j]) {
                	dp[i+1][j+1] = 1 + dp[i][j];
                	par[i+1][j+1] = 2;
                }
            }
        }
        int cur_i = A.length(), cur_j = B.length();
        StringBuilder builder = new StringBuilder();
        while (cur_i > 0 && cur_j > 0) {
        	if (par[cur_i][cur_j] == 0) --cur_j;
        	else if (par[cur_i][cur_j] == 1) --cur_i;
        	else {
        		--cur_i; --cur_j;
        		builder.append(A.charAt(cur_i));
        	}
        }
        builder.reverse();
        System.out.println(builder.toString());
        return dp[A.length()][B.length()];
    }
	
	public static void main(String[] args) {
		LCS lcs = new LCS("BDCABA", "ABCBDAB");
		System.out.println(lcs.longestCommonSubsequence());
	}
}