class Solution {
    static class Event {
        int x;
        int intervalId;
        boolean isStart;
        Event(int x, int intervalId, boolean isStart) {
            this.x = x;
            this.intervalId = intervalId;
            this.isStart = isStart;
        }
    };
    public int jobScheduling(int[] startTime, int[] endTime, int[] profit) {
        Event events[] = new Event[2 * startTime.length];
        for (int i = 0; i < startTime.length; ++i) {
            events[2 * i] = new Event(startTime[i], i, true);
            events[2 * i + 1] = new Event(endTime[i], i, false);
        }
        // Make timestamps unique.
        Arrays.sort(events, new Comparator<Event>() {
            @Override
            public int compare(Event a, Event b) {
                if (a.x == b.x) return a.isStart ? 1 : -1;
                return Integer.compare(a.x, b.x);
            }
        });
        int prev = -1, cur_x = -1;
        for (int i = 0; i < events.length; ++i) {
            if (prev != events[i].x) {
                ++cur_x;
                prev = events[i].x;
            }
            events[i].x = cur_x;
            if (events[i].isStart) startTime[events[i].intervalId] = cur_x;
        }
        
        // Solve the DP recurrence.
        int dp[] = new int[cur_x + 1];
        for (int i = 0; i < events.length; ++i) {
            int x = events[i].x;
        	if (x > 0) dp[x] = Math.max(dp[x], dp[x - 1]);
            if (!events[i].isStart) {
            	int id = events[i].intervalId;
                dp[x] = Math.max(dp[x], dp[startTime[id]] + profit[id]);
            }
            // System.out.println(x + " : " + dp[x]);
        }
        return dp[cur_x];
    }
}
