class Solution {
public:
    
    int norm(int c) {
        return c + 128;
    }
    
    vector<int> countChars(const string& s) {
        vector<int> count(256, 0);
        for (char c : s) {
            ++count[norm(c)];
        }
        return count;
    }
    
    string minWindow(string s, string t) {
        std::vector<int> target = countChars(t);
        std::vector<int> found(256, 0);
        int en = 0;
        int count = 0;
        int min_idx = -1;
        int min_len = -1;
        for (int k = 0; k < s.size(); ++k) {
            // Remove the previous value.
            if (k != 0) {
                int prev = norm(s[k-1]);
                if (found[prev] <= target[prev]) {
                    --count;
                }
                --found[prev];
            }
            // Reach the best place for the current value.
            while (count != t.size() && en < s.size()) {
                int cur = norm(s[en]);
                ++found[cur];
                if (found[cur] <= target[cur]) {
                    ++count;
                }
                ++en;
            }
            
            // If no such value exist, then break.
            if (en == s.size() && count != t.size()) {
                break;
            }
            
            // Else: update the current best. 
            int cur_len = en - k;
            if (min_idx == -1 || min_len > cur_len) {
                min_len = cur_len;
                min_idx = k;
            }
        }
        if (min_idx == -1) {
            return "";
        }
        return s.substr(min_idx, min_len);
    }
};
