public class LongestIncreasingSubsequence {
    public static int[] findALIS(int[] nums) {
        int dp[] = new int[nums.length];
        int par[] = new int[nums.length];
        int mx = 1, maxValue = 0;
        for (int i = 0; i < nums.length; ++i) {
            dp[i] = 1; // Sequence with {nums[i]}
            par[i] = -1;
            for (int j = 0; j < i; ++j) {
                if (nums[j] < nums[i] && dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    par[i] = j;
                }
            }
            if (dp[i] > mx) {
            	mx = dp[i];
            	maxValue = i;
            }
        }
        // Reconstruct the LIS.
        int cur = maxValue;
        int lis[] = new int[mx];
        while (cur != -1) {
        	lis[--mx] = nums[cur];
        	cur = par[cur];
        }
        return lis;
    }
    
    public static void main(String[] args) {
    	int[] ans = findALIS(new int[] {10,9,2,5,3,7,101,18});
    	for (int v : ans) System.out.println(v);
    }
}
